package com.zswl.cloud.springBtach.server.boot;

import cn.hutool.json.JSONUtil;
import com.github.microservice.auth.client.service.EnterpriseService;
import com.xiaoju.open.oil.commons.config.OilConfig;
import com.xiaoju.open.oil.core.QueryClient;
import com.xiaoju.open.oil.core.QueryClientFactory;
import com.xiaoju.open.oil.interfaces.domain.AllowancePromotionInfo;
import com.xiaoju.open.oil.interfaces.domain.GenPromotionInfo;
import com.xiaoju.open.oil.interfaces.request.QueryGetPromotionRequest;
import com.xiaoju.open.oil.interfaces.request.QueryOrderPromotionListRequest;
import com.xiaoju.open.oil.interfaces.request.miniprogram.MiniProgramQueryNewOrderRequest;
import com.xiaoju.open.oil.interfaces.request.miniprogram.MiniQueryCalPriceRequest;
import com.xiaoju.open.oil.interfaces.response.miniprogram.MiniQueryCalPriceResponse;
import com.xiaoju.open.oil.interfaces.response.miniprogram.MiniQueryNewOrderResponse;
import com.zhongshu.payment.client.service.v2.OrderService2;
import com.zhongshu.payment.client.service.v2.PaymentService2;
import com.zswl.cloud.shop.client.dto.life.TripartiteShopDto;
import com.zswl.cloud.shop.client.service.GoodsService;
import com.zswl.cloud.shop.client.service.ShopService;
import com.zswl.cloud.springBatch.client.model.dfy.Hotel.request.QueryNewRequest;
import com.zswl.cloud.springBatch.client.model.dfy.Ticket.request.PrivilegeTicketListRequest;
import com.zswl.cloud.springBatch.client.model.dfy.Ticket.request.ScenicDetailRequest;
import com.zswl.cloud.springBatch.client.model.dfy.Ticket.request.ScenicListRequest;
import com.zswl.cloud.springBatch.client.model.dfy.Ticket.response.ScenicListResponse;
import com.zswl.cloud.springBtach.server.core.api.dfy.DomesticHotelApi;
import com.zswl.cloud.springBtach.server.core.api.dfy.TicketApi;
import com.zswl.cloud.springBtach.server.core.api.xiaoju.XiaoJuApi;
import com.zswl.cloud.springBtach.server.core.api.xiaoju.XiaoJuApi2;
import com.zswl.cloud.springBtach.server.core.api.ypp.YppApi;
import com.zswl.cloud.springBtach.server.core.controller.TestSpringBatch;
import com.zswl.cloud.springBtach.server.core.dao.XiaoJuStoreDao;
import com.zswl.cloud.springBtach.server.core.domain.XiaoJuStore;
import com.zswl.cloud.springBtach.server.core.service.PaymentService;
import com.zswl.cloud.springBtach.server.core.service.XiaoJuService;
import com.zswl.cloud.springBtach.server.core.service.impl.OrderServiceImpl;
import lombok.extern.log4j.Log4j2;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.mongodb.core.MongoTemplate;

import java.util.List;

@SpringBootTest
@Log4j2
public class ServerApplicationTests {
    @Autowired
    YppApi piaoPiaoApi;

    @Autowired
    TestSpringBatch testSpringBatch;

    @Autowired
    OrderServiceImpl orderService;


    @Autowired
    EnterpriseService enterpriseService;

    @Autowired
    PaymentService2 paymentService2;

    @Autowired
    XiaoJuApi xiaoJuApi;

    @Autowired
    XiaoJuApi2 xiaoJuApi2;

    @Autowired
    PaymentService paymentService;
    @Autowired
    private XiaoJuStoreDao xiaoJuStoreDao;


    @Autowired
    TicketApi diFengYunApi;

    @Test
    public void dfy() {


        ScenicListRequest scenic = new ScenicListRequest();
        scenic.setKey("南京");
        scenic.setPage(1);
        scenic.setPageSize(10);



        ScenicListResponse scenicListResponse = diFengYunApi.scenicList(scenic);
        System.out.println(JSONUtil.toJsonStr(scenicListResponse));


        ScenicDetailRequest  scenicDetailRequest= new ScenicDetailRequest();
        scenicDetailRequest.setScenicId("poi1745");

//        ScenicDetailResponse scenicDetailResponse = diFengYunApi.scenicDetail(scenicDetailRequest);
//        System.out.println(JSONUtil.toJsonStr(scenicDetailResponse));

        PrivilegeTicketListRequest privilegeTicketListRequest = new PrivilegeTicketListRequest();
        privilegeTicketListRequest.setPage(1);
        privilegeTicketListRequest.setPageSize(20);

//        PrivilegeTicketListResponse scenicListResponse = diFengYunApi.privilegeTicketList(privilegeTicketListRequest);
//        System.out.println(JSONUtil.toJsonStr(scenicListResponse));

    }


    @Autowired
    DomesticHotelApi domesticHotelApi;
    @Test
    public void hotel(){
        QueryNewRequest queryNewRequest = new QueryNewRequest();
        queryNewRequest.setKeywords("日本");
        domesticHotelApi.queryNew(queryNewRequest);


    }


    @Autowired
    ShopService shopService;

    @Test
    public void test3() {

        for (XiaoJuStore xiaoJuStore : xiaoJuStoreDao.findAll()) {

            TripartiteShopDto tripartiteShopDto = new TripartiteShopDto();
            tripartiteShopDto.setKey("加油");
            tripartiteShopDto.setTripartiteId(xiaoJuStore.getStoreId());
            tripartiteShopDto.setShopName(xiaoJuStore.getStoreName());
            tripartiteShopDto.setShopMenuId("4");
            tripartiteShopDto.setProvince(xiaoJuStore.getProvinceName());
            tripartiteShopDto.setCity(xiaoJuStore.getCityName());
            tripartiteShopDto.setAddress(xiaoJuStore.getAddress());
            tripartiteShopDto.setMapLon(String.valueOf(xiaoJuStore.getLon()));
            tripartiteShopDto.setMapLat(String.valueOf(xiaoJuStore.getLat()));
            tripartiteShopDto.setLogoPath(xiaoJuStore.getLogo());
            if (xiaoJuStore.getPicList().size() > 0) {
                tripartiteShopDto.setDetailImg(xiaoJuStore.getPicList().get(0));
            }
            tripartiteShopDto.setTripartiteJson(JSONUtil.toJsonStr(xiaoJuStore));

            com.zswl.cloud.shop.client.ret.ResultContent resultContent = shopService.tripartiteShop(tripartiteShopDto);
            log.info("创建店铺响应{}", JSONUtil.toJsonStr(resultContent));
        }




    }

    @Autowired
    XiaoJuService xiaoJuService;


    @Autowired
    GoodsService goodsService;

    @Autowired
    OrderService2 orderService2;
    @Autowired
    MongoTemplate mongoTemplate;


    @Autowired
    OilConfig oilConfig;

    @Test
    public void queryNewOrderq1() {
        MiniProgramQueryNewOrderRequest newOrderRequest = new MiniProgramQueryNewOrderRequest();
        newOrderRequest.setStoreId("5154031457384536897");
        newOrderRequest.setGunNo("2");
        newOrderRequest.setLat(30.280486F);
        newOrderRequest.setLon(120.094503F);
        newOrderRequest.setLitre(13450);
        newOrderRequest.setOpenChannel(1);
        newOrderRequest.setOrderAmount(10000);
        newOrderRequest.setRealAmount(7708);
        newOrderRequest.setOutOrderId("13232344343");
        newOrderRequest.setOutUserId("65fe583d74d67a7dbd842b45");
        newOrderRequest.setServiceFee(312);
        newOrderRequest.setItemId(4879454965524071453L);
        newOrderRequest.setMobile("13368172379");

        com.xiaoju.open.oil.interfaces.domain.AllowanceInfo allowanceInfo = new com.xiaoju.open.oil.interfaces.domain.AllowanceInfo();

        newOrderRequest.setPromotionInfo(List.of());


        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        MiniQueryNewOrderResponse response = queryClient.apiMini().queryNewOrder(newOrderRequest);
        System.out.println(response);

    }

    // 下单前查询最优可用券
    @Test
    public void queryOrderPromotionList() {
        QueryOrderPromotionListRequest request = new QueryOrderPromotionListRequest();
        request.setOutUserId("80200281708");
        request.setStoreId("5429504232738269218");
        request.setAllowanceType(2);
        request.setOrderAmount(24500);

        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        List<AllowancePromotionInfo> response = queryClient.promotion().queryOrderPromotionList(request);
        System.out.println(response);
    }


    // 券发放
    @Test
    public void getPromotion() {
        QueryGetPromotionRequest request = new QueryGetPromotionRequest();
        request.setOutUserId("18874");
        request.setActivityId("872933491179388928");
        request.setTradeNo("2202071307003069990");

        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        List<GenPromotionInfo> response = queryClient.promotion().getPromotion(request);
        System.out.println(response);
    }

    @Test
    public void queryCalPrice() {
        MiniQueryCalPriceRequest calPriceRequest = new MiniQueryCalPriceRequest();
        calPriceRequest.setStoreId("5429780558166639664");
        calPriceRequest.setAmount(10000);
        calPriceRequest.setItemName("92#");
        calPriceRequest.setOpenChannel(1);
        calPriceRequest.setOutUserId("65fe583d74d67a7dbd842b45");

        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        MiniQueryCalPriceResponse response = queryClient.apiMini().queryCalPrice(calPriceRequest);
        System.out.println(JSONUtil.toJsonStr(response));

    }

    @Test
    public void queryNewOrder() {
        MiniProgramQueryNewOrderRequest newOrderRequest = new MiniProgramQueryNewOrderRequest();
        newOrderRequest.setStoreId("5154031457384536897");
        newOrderRequest.setOutUserId("1640563200");
        newOrderRequest.setMobile("13368172379");
        newOrderRequest.setGunNo("2");
        newOrderRequest.setLat(30.280486F);
        newOrderRequest.setLon(120.094503F);
        newOrderRequest.setLitre(13450);
        newOrderRequest.setOpenChannel(1);
        newOrderRequest.setOrderAmount(10000);
        newOrderRequest.setRealAmount(7708);
        newOrderRequest.setOutOrderId("13232344343");
        newOrderRequest.setServiceFee(312);
        newOrderRequest.setItemId(4879454965524071453L);
        QueryClient queryClient = QueryClientFactory.create(oilConfig);
        MiniQueryNewOrderResponse response = queryClient.apiMini().queryNewOrder(newOrderRequest);

    }


}
